/*
 Copyright (c) 2020 Swift Models Generated from JSON powered by http://www.json4swift.com

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

 For support, please feel free to contact me at https://www.linkedin.com/in/syedabsar

 */

import Foundation
import ObjectMapper
import RealmSwift
public class PQEditVideoMetaDataModel: PQEditBaseModel {
    // 是否添加片尾（1：是，0：否）
    @objc dynamic public var appendTailStatus: Int = 0
    @objc dynamic public var coverUrl: String = ""
    @objc dynamic public var duration: Float64 = 0
    @objc dynamic public var title: String = ""
    // 输出视频的最终画布宽高，和canvasType 保持一致，只有在用户操作时设置时，其它地方都是只读
    @objc dynamic public var videoHeight: Int = 1080
    @objc dynamic public var videoWidth: Int = 1080
    // 画布类型（1：原始，2：9比16，3：1比1，4：16比9）
    @objc dynamic public var canvasType: Int = 1

    // 素材文件总大小
    @objc dynamic public var materialTotalSize: Float64 = 0

    required convenience init?(map _: Map) {
        self.init()
    }

    public  override func mapping(map: Map) {
        appendTailStatus <- map["appendTailSftatus"]
        coverUrl <- map["coverUrl"]
        duration <- (map["duration"], timeTransform)
        title <- map["title"]
        videoHeight <- map["videoHeight"]
        videoWidth <- map["videoWidth"]
        canvasType <- map["canvasType"]
        materialTotalSize <- map["materialTotalSize"]
    }
}
